#version 400

varying vec4 vpos;

//varying vec2 texCoord;
//uniform sampler2D colorMap;

//uniform mat4 depthMVP;
/*
void main (void)
{
//vec2 nutexcoord;
//	nutexcoord=texCoord;
//	nutexcoord.x=1.0-nutexcoord.x;

	//gl_FragColor = texture2D(colorMap, texCoord);
    //gl_FragColor = vec4(vec3(gl_FragDepth),1.0f);


//    if (texture2D(colorMap, texCoord).a>0.8f) //should be 0.5 i guess
        gl_FragColor = vec4(vec3(gl_FragCoord.z),1.0f);
//    else discard;


	//gl_FragColor = texture2D(colorMap, texCoord)*vColor;
	//gl_FragColor = texture2D(colorMap, nutexcoord);
}
*/
//#version 120
// It was expressed that some drivers required this next line to function properly
precision highp float;
#define MAX_LIGHTS 14
in vec3 alightVec[MAX_LIGHTS];
in vec3 aeyeVec[MAX_LIGHTS];
in vec2 texCoord;

uniform vec4 glColor;

//in vec3 vNormal;

uniform float lightsEnabled[MAX_LIGHTS];
uniform float lightsinvRadius[MAX_LIGHTS];
uniform float lightMapSelect[MAX_LIGHTS];


uniform float lightsAmbientr[MAX_LIGHTS];
uniform float lightsAmbientg[MAX_LIGHTS];
uniform float lightsAmbientb[MAX_LIGHTS];

uniform float lightsDiffuser[MAX_LIGHTS];
uniform float lightsDiffuseg[MAX_LIGHTS];
uniform float lightsDiffuseb[MAX_LIGHTS];

uniform float lightsSpecularr[MAX_LIGHTS];
uniform float lightsSpecularg[MAX_LIGHTS];
uniform float lightsSpecularb[MAX_LIGHTS];



uniform sampler2D colorMap;
uniform sampler2D normalMap;
uniform sampler2D lightMap;
uniform sampler2D specularMap;
//uniform float invRadius;
//out vec4 gl_FragColor;

void main (void)
{

    vec3 lightVec;
    vec3 eyeVec;
    vec4 accvDiffuse = vec4(0.0);
    vec4 accvSpecular = vec4(0.0);
    float distSqr;
    vec3 lVec;
    vec3 vVec;
    float att;
    vec4 base;
    vec4 vAmbient;
    vec3 bump;
    float diffuse;
    vec4 vDiffuse;
    vec4 vSpecular;
    float specular;
    vec3 nrmltexture;

    base = texture2D(colorMap, texCoord);
    //vAmbient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;
    vAmbient = vec4(1.0f,1.0f,1.0f,1.0f)
               * vec4(lightsAmbientr[0],lightsAmbientg[0],lightsAmbientb[0],1.0f);
/*
    for (int i=0; i<MAX_LIGHTS; i++)
    {
        if (lightsEnabled[i]>0.0)
        {
            lightVec=alightVec[i];
            eyeVec=aeyeVec[i];
            distSqr = dot(lightVec, lightVec);
            att = clamp(1.0 - lightsinvRadius[i] * sqrt(distSqr), 0.0, 1.0);
            lVec = lightVec * inversesqrt(distSqr);
            vVec = normalize(eyeVec);

            //nrmltexture= texture2D(normalMap, texCoord).xyz;
            //nrmltexture.z=nrmltexture.z*-1.0f;
            //bump = normalize(nrmltexture * 2.0f - 1.0);
            bump = normalize( texture2D(normalMap, texCoord).xyz * 2.0f - 1.0);
            //bump = vec3(0.0,0.0,1.0);

            //diffuse = max( dot(lVec, bump), 0.0 );
            diffuse = clamp( dot(lVec, bump), 0.0, 1.0 );
//	vDiffuse = gl_LightSource[i].diffuse * gl_FrontMaterial.diffuse * diffuse *
            vDiffuse = vec4(lightsDiffuser[i],lightsDiffuseg[i],lightsDiffuseb[i],1.0f) * diffuse *
                       texture2D(lightMap, vec2(diffuse-0.01,lightMapSelect[i]));
            accvDiffuse = accvDiffuse + vDiffuse * att;

            //vDiffuse = gl_LightSource[i].diffuse * diffuse *
            //         texture2D(lightMap, vec2(diffuse-0.01,lightMapSelect[i]));
            //accvDiffuse = accvDiffuse + vDiffuse;

            //specular = pow(clamp(dot(reflect(-lVec, bump), vVec), 0.0, 1.0),
            //gl_FrontMaterial.shininess );

            //specular = pow(clamp(dot(reflect(-lVec, bump), vVec), 0.0, 1.0), 32.0 ) * texture2D(specularMap, texCoord).r; //here shiness is replaced with 1.0, should introduce material functionality in obj loader //16.0
            specular= clamp( dot(lVec, bump), 0.0, 1.0 ) * texture2D(specularMap, texCoord).r;

            //vec4 vSpecular = gl_LightSource[0].specular * gl_FrontMaterial.specular * specular;
//	vSpecular = gl_LightSource[i].specular * gl_FrontMaterial.specular * specular *
            vSpecular = vec4(lightsSpecularr[i],lightsSpecularg[i],lightsSpecularb[i],1.0f)* specular *
                        texture2D(lightMap, vec2(specular-0.01,lightMapSelect[i]));
            accvSpecular = accvSpecular + vSpecular * att;

            //vSpecular = gl_LightSource[i].specular * specular * texture2D(lightMap, vec2(specular-0.01,lightMapSelect[i]));
            //accvSpecular = accvSpecular + vSpecular;
        }
    }

*/
    //gl_FragColor = ( vAmbient*base + accvDiffuse*base + accvSpecular)*glColor;

    //if (texture2D(colorMap, texCoord).a>0.8f)
        //gl_FragColor = vec4(vec3(gl_FragCoord.z),1.0f);
        //gl_FragColor = vec4(vec3(vpos.z),1.0f);
        gl_FragColor = vec4(vec3(gl_FragCoord.w),1.0f);










    float depth=vpos.z/200.0f;
    double x2=depth*(65536*256);
    double r2=floor(x2/(65536)); x2=x2-r2*(65536);
    double g2=floor(x2/(256)); x2=x2-g2*(256);
    double b2=floor(x2/(1)); x2=x2-b2*(1);
    //double a2=x2;
    float r1=float(r2/256.0f);
    float g1=float(g2/256.0f);
    float b1=float(b2/256.0f);
    //float a1=float(a2/256.0f);

    //gl_FragColor = vec4(vpos.zzz/200.0f,1.0f);//this normalizing value is from projection matrix setup
    gl_FragColor = vec4(r1,g1,b1,1.0f);





    //else discard;

    //gl_FragColor = gl_FragColor * glColor;

    //gl_FragColor = vec4(vNormal.x,vNormal.y,vNormal.z,1.0);
    //gl_FragColor = ( vAmbient*base + vDiffuse*base + vSpecular) * att;
    //gl_FragColor = ( vAmbient*base + vDiffuse*base + texture2D(lightMap, vec2(1.0-specular,0))) * att;
}


/*
uniform sampler2D color_texture;
uniform sampler2D normal_texture;

void main() {

// Extract the normal from the normal map
vec3 normal = normalize(texture2D(normal_texture, gl_TexCoord[0].st).rgb * 2.0 - 1.0);

// Determine where the light is positioned (this can be set however you like)
vec3 light_pos = normalize(vec3(1.0, 1.0, 1.5));

// Calculate the lighting diffuse value
float diffuse = max(dot(normal, light_pos), 0.0);

vec3 color = diffuse * texture2D(color_texture, gl_TexCoord[0].st).rgb;

// Set the output color of our current pixel
gl_FragColor = vec4(color, 1.0);
}
*/

/*
in  vec3 ex_Color;
out vec4 gl_FragColor;

uniform sampler2D colorMap;
in vec2 fragtextureCoord;

void main(void) {
vec4 base;

    // Pass through our original color with full opacity.
    //gl_FragColor = vec4(ex_Color,1.0);

	base = texture2D(colorMap, fragtextureCoord);
	gl_FragColor = base;
}
*/
